Attribute VB_Name = "modDynHighGUI"
' Edit Control Notification Codes
Public Const EN_SETFOCUS = &H100
Public Const EN_KILLFOCUS = &H200
Public Const EN_CHANGE = &H300
Public Const EN_UPDATE = &H400
Public Const EN_ERRSPACE = &H500
Public Const EN_MAXTEXT = &H501
Public Const EN_HSCROLL = &H601
Public Const EN_VSCROLL = &H602

' Listbox messages
Public Const LB_ADDSTRING = &H180
Public Const LB_INSERTSTRING = &H181
Public Const LB_DELETESTRING = &H182
Public Const LB_SELITEMRANGEEX = &H183
Public Const LB_RESETCONTENT = &H184
Public Const LB_SETSEL = &H185
Public Const LB_SETCURSEL = &H186
Public Const LB_GETSEL = &H187
Public Const LB_GETCURSEL = &H188
Public Const LB_GETTEXT = &H189
Public Const LB_GETTEXTLEN = &H18A
Public Const LB_GETCOUNT = &H18B
Public Const LB_SELECTSTRING = &H18C
Public Const LB_DIR = &H18D
Public Const LB_GETTOPINDEX = &H18E
Public Const LB_FINDSTRING = &H18F
Public Const LB_GETSELCOUNT = &H190
Public Const LB_GETSELITEMS = &H191
Public Const LB_SETTABSTOPS = &H192
Public Const LB_GETHORIZONTALEXTENT = &H193
Public Const LB_SETHORIZONTALEXTENT = &H194
Public Const LB_SETCOLUMNWIDTH = &H195
Public Const LB_ADDFILE = &H196
Public Const LB_SETTOPINDEX = &H197
Public Const LB_GETITEMRECT = &H198
Public Const LB_GETITEMDATA = &H199
Public Const LB_SETITEMDATA = &H19A
Public Const LB_SELITEMRANGE = &H19B
Public Const LB_SETANCHORINDEX = &H19C
Public Const LB_GETANCHORINDEX = &H19D
Public Const LB_SETCARETINDEX = &H19E
Public Const LB_GETCARETINDEX = &H19F
Public Const LB_SETITEMHEIGHT = &H1A0
Public Const LB_GETITEMHEIGHT = &H1A1
Public Const LB_FINDSTRINGEXACT = &H1A2
Public Const LB_SETLOCALE = &H1A5
Public Const LB_GETLOCALE = &H1A6
Public Const LB_SETCOUNT = &H1A7
Public Const LB_MSGMAX = &H1A8

Public Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long

Public OPENEDFILE As String
Public SYNTAXFILE As String

Private NumCount As Integer



Public Sub EvalSynLine(t As TreeView, header As String, l As String)
    Dim cLft As String, cRgt As String, tmpHdr As String
    Dim tmpLn As String
    
    With t
        
        tmpHdr = header
        tmpLn = l
        
        Select Case LCase(header)
            Case "[keywords]"
            
            Case "[func subs]"
            
            Case "[comments]"
                cLft = LCase(GetTokenTxt(Trim(tmpLn), "=", True))
                cRgt = GetTokenTxt(Trim(tmpLn), "=", False)
                
                tmpHdr = tmpHdr & cLft
                tmpLn = cRgt
            Case "[block]"
            
            Case "[stringdelim]"
            
            Case "[scope]"
            
            Case "[text]"
            
            Case "[operators]"
        
        End Select
        
        On Error Resume Next
        .Nodes.Add tmpHdr, tvwChild, , tmpLn
    End With
End Sub

Public Function LoadSynGUIFile(sPath As String, t As TreeView) As Boolean
    Dim cHeader As String
    Dim f As Byte
    Dim i As Integer
    Dim c As Node
    
    'Closes all open files...
    Close
    'Gets a # based on the # of files opened...
    f = FreeFile
    
    On Error Resume Next
    Open sPath For Input As #f
    
    Do While Not EOF(f)
        Line Input #f, cLn
        If Left(cLn, 1) <> ";" And Left(cLn, 1) <> "" Then
            If Left(Trim(cLn), 1) = "[" And Right(Trim(cLn), 1) = "]" Then
                'Sets the current header as it changes
                'within the syntax file...
                cHeader = cLn
                
                On Error Resume Next
                i = i + 1
                Set c = t.Nodes.Add(, tvwParent, LCase(cHeader), Mid(cHeader, 2, Len(cHeader) - 2))
                
                If LCase(cHeader) = "[comments]" Then
                    t.Nodes.Add LCase(cHeader), tvwChild, LCase(cHeader & "SingleLine"), "Single Line"
                    t.Nodes.Add LCase(cHeader), tvwChild, LCase(cHeader & "MultiLineStart"), "Multi-line Start"
                    t.Nodes.Add LCase(cHeader), tvwChild, LCase(cHeader & "MultiLineEnd"), "Multi-line End"
                End If
                '
                ' Use Line below for VB6
                '
                'c.Bold = True
                '
                ' Use this line for VB5
                '
                BoldTreeNode t, c
                
            Else
                'Evaluates each line as it's read...
                Call EvalSynLine(t, LCase(cHeader), Trim(cLn))
                'On Error Resume Next
                't.Nodes.Add cHeader, tvwChild, , cLn
            End If
        End If
    Loop
End Function

Private Sub BoldTreeNode(t As TreeView, nNode As Node)
'
' Make a tree node bold
'
' Many thanks to VBNet for this code
'

On Error GoTo vbErrorHandler

    Dim TVI As TVITEM
    Dim lRet As Long
    Dim hItemTV As Long
    Dim lHwnd As Long
    
    Set t.SelectedItem = nNode
    
    lHwnd = t.hwnd
    hItemTV = SendMessageLong(lHwnd, TVM_GETNEXTITEM, TVGN_CARET, 0&)
    
    If hItemTV > 0 Then
        With TVI
            .hItem = hItemTV
            .mask = TVIF_STATE
            .stateMask = TVIS_BOLD
            lRet = SendMessageAny(lHwnd, TVM_GETITEM, 0&, TVI)
            .State = TVIS_BOLD
        End With
        lRet = SendMessageAny(lHwnd, TVM_SETITEM, 0&, TVI)
    End If
    
    Exit Sub

vbErrorHandler:
    MsgBox Err.Number & " " & Err.Description & " " & Err.Source, , "frmCodeLib::BoldTreeNode"

End Sub

